Stateless Best Effort Multicast Simulations
Huaimo Chen
Futurewei
Boston, MA
USA
hchen.ietf@gmail.com
Donald E. Eastlake 3rd
Futurewei
2386 Panoramic Circle
Apopka, FL
32703
USA
+1-508-333-2270
d3e3e3@gmail.com
Mike McBride
Futurewei
michael.mcbride@futurewei.com
Yanhe Fan
Casa Systems
USA
yfan@casa-systems.com
Gyan S. Mishra
Verizon
13101 Columbia Pike
Silver Spring
MD 20904
USA
301 502-1347
gyan.s.mishra@verizon.com
Yisong Liu
China Mobile
liuyisong@chinamobile.com
Aijun Wang
China Telecom
Beiqijia Town, Changping District
Beijing
102209
China
wangaj3@chinatelecom.cn
Xufeng Liu
IBM Corporation
USA
xufeng.liu.ietf@gmail.com
Lei Liu
Fujitsu
USA
liulei.kddi@gmail.com
2024
This document describes simulations of stateless best effort Multicasts and lists a set of simulation results for different large network sizes and different tree sizes.

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.

Introduction
For a tree given by its root/ingress and leaves/egresses, a few of solutions are proposed to multicast data from the ingress to the egresses using the shortest IGP paths to the egresses. They include:
o BEM-MRH: Stateless Best Effort Multicast Using MRH [I-D.chen-pim-be-mrh].
o BIER: Multicast Using Bit Index Explicit Replication [RFC8279].
o RGB: RGB (Replication through Global Bitstring) Segment for Multicast Source Routing over IPv6 [I-D.lx-msr6-rgb-segment].
This document describes simulations of stateless best effort Multicasts and lists a set of simulation results for different large network sizes and different tree sizes.

Acronyms
The following acronyms are used in this document:
CE: Customer edge/equipment.
MRH: Multicast Routing Header.
P2MP: Point 2 Multi-Point.
PE: Provider Edge.

Simulations of BE Multicasts
A simulation of a BE Multicast means a computation of the encoding of a tree in a given network according to the BE Multicast. The tree has a number of egresses/leaves, which is the size of the tree. The network has a number of nodes, which is the size of the network.
For a given network size (i.e., a number of nodes in the network), we assume that half of the nodes are PEs. For a given tree size (i.e., a number of leaves/egresses) T, we select T egress nodes from the PEs randomly first. And then we compute the encoding of the tree with these T selected egress nodes. The computation results include the total size of the encoding of the tree and the number of packet copies that the ingress/root of the tree will encapsulate and send.
For simulating Stateless Best Effort Multicast Using MRH (BEM-MRH) defined in [I-D.chen-pim-be-mrh], we compute the encoding according to BE-MRH for each of the trees with different tree sizes in each of the networks with different network sizes.

Some Simulation Results
Suppose that we have a set of network sizes netSizes = {4096, 8192, 16384} and a set of tree sizes treeSizes = {16, 24, 32, 48, 64, 80, 96, 128}. We simulate the BEM-MRH and BIER for each tree size in treeSizes for each network size in netSizes. For BIER, we use BitString length 256 (bits).
Figure 1 shows the results of simulating the BEM-MRH and BIER for every tree size for network size 4096.

Results of simulating BEM-MRH and BIER for network with 4096 nodes

+======+=========================+=========================+
|      |       BEM-MRH           |        BIER             |
| Tree | Encoding |Number of     | Encoding |Number of     |
| Size | Size     |Packet Copies | Size     |Packet Copies |
+======+==========+==============+==========+==============+
|  16  |    32    |      1       |    224   |       7      |
+------+----------+--------------+----------+--------------+
|  24  |    47    |      1       |    256   |       8      |
+------+----------+--------------+----------+--------------+
|  32  |    62    |      1       |    256   |       8      |
+------+----------+--------------+----------+--------------+
|  48  |    93    |      1       |    256   |       8      |
+------+----------+--------------+----------+--------------+
|  64  |   128    |      1       |    256   |       8      |
+------+----------+--------------+----------+--------------+
|  80  |   154    |      1       |    256   |       8      |
+------+----------+--------------+----------+--------------+
|  96  |   164    |      1       |    256   |       8      |
+------+----------+--------------+----------+--------------+
| 128  |   196    |      1       |    256   |       8      |
+======+==========+==============+==========+==============+
From the simulation results of BEM-MRH in the figure, we see that the number of packet copies is 1 for any tree size (refer to the third column of the table).
This indicates that after receiving a multicast packet from a traffic source such as a CE, the ingress/root of the tree can encapsulate one packet copy and send the packet to the egress/leaf nodes of the tree through using BEM-MRH.
From the simulation results of BIER in the figure, we see that the number of packet copies is 7 for tree size 16 and 8 for any other tree size (refer to the last column of the table).
This indicates that after receiving a multicast packet from a traffic source such as a CE, the ingress/root of the tree need to make 7/8 packet copies, encapsulate each of the copies and send the packet copies to the egress/leaf nodes of the tree through using BIER.
From the simulation results of BEM-MRH in the figure, we see that the total size of the encoding tree is 32 (bytes) for a tree with 16 leaves/egresses, 47 (bytes) for a tree with 24 leaves/egresses, ..., 196 (bytes) for a tree with 128 leaves/egresses (refer to the second column of the table).
The total size of the encoding tree is always less than or equal to two times the tree size.
From the simulation results of BIER in the figure, we see that the total size of the encoding tree is 224 (bytes) for a tree with 16 leaves/egresses, and 256 (bytes) for any other tree size (refer to the fourth column of the table).
Figure 2 shows the results of simulating the BEM-MRH and BIER for every tree size for network size 8192.

Results of simulating BEM-MRH and BIER for network with 8192 nodes

+======+=========================+=========================+
|      |       BEM-MRH           |        BIER             |
| Tree | Encoding |Number of     | Encoding |Number of     |
| Size | Size     |Packet Copies | Size     |Packet Copies |
+======+==========+==============+==========+==============+
|  16  |    32    |      1       |    320   |      10      |
+------+----------+--------------+----------+--------------+
|  24  |    48    |      1       |    352   |      11      |
+------+----------+--------------+----------+--------------+
|  32  |    64    |      1       |    416   |      13      |
+------+----------+--------------+----------+--------------+
|  48  |    96    |      1       |    448   |      14      |
+------+----------+--------------+----------+--------------+
|  64  |   124    |      1       |    512   |      16      |
+------+----------+--------------+----------+--------------+
|  80  |   159    |      1       |    512   |      16      |
+------+----------+--------------+----------+--------------+
|  96  |   187    |      1       |    512   |      16      |
+------+----------+--------------+----------+--------------+
| 128  |   235    |      1       |    512   |      16      |
+======+==========+==============+==========+==============+
From the simulation results of BEM-MRH in the figure, we see that the number of packet copies is 1 for any tree size (refer to the third column of the table).
This indicates that after receiving a multicast packet from a traffic source such as a CE, the ingress/root of the tree can encapsulate one packet copy and send the packet to the egress/leaf nodes of the tree through using BEM-MRH.
From the simulation results of BIER in the figure, we see that the number of packet copies is from 10 to 16 for tree size from 16 to 128 (refer to the last column of the table).
This indicates that after receiving a multicast packet from a traffic source such as a CE, the ingress/root of the tree need to make 10 to 16 packet copies, encapsulate each of the copies and send the packet copies to the egress/leaf nodes of the tree through using BIER.
From the simulation results of BEM-MRH in the figure, we see that the total size of the encoding tree is 32 (bytes) for a tree with 16 leaves/egresses, 48 (bytes) for a tree with 24 leaves/egresses, ..., 235 (bytes) for a tree with 128 leaves/egresses (refer to the second column of the table).
The total size of the encoding tree is always less than or equal to two times the tree size.
From the simulation results of BIER in the figure, we see that the total size of the encoding tree is from 320 to 512 (bytes) for a tree with size from 16 to 128 (leaves/egresses) (refer to the fourth column of the table).
Figure 3 shows the results of simulating the BEM-MRH and BIER for every tree size for network size 16384.

Results of simulating BEM-MRH and BIER for network with 16384 nodes

+======+=========================+=========================+
|      |       BEM-MRH           |        BIER             |
| Tree | Encoding |Number of     | Encoding |Number of     |
| Size | Size     |Packet Copies | Size     |Packet Copies |
+======+==========+==============+==========+==============+
|  16  |    32    |      1       |    384   |      12      |
+------+----------+--------------+----------+--------------+
|  24  |    48    |      1       |    480   |      15      |
+------+----------+--------------+----------+--------------+
|  32  |    64    |      1       |    704   |      22      |
+------+----------+--------------+----------+--------------+
|  48  |    96    |      1       |    800   |      25      |
+------+----------+--------------+----------+--------------+
|  64  |   126    |      1       |    896   |      28      |
+------+----------+--------------+----------+--------------+
|  80  |   158    |      1       |    928   |      29      |
+------+----------+--------------+----------+--------------+
|  96  |   192    |      1       |    992   |      31      |
+------+----------+--------------+----------+--------------+
| 128  |   256    |      1       |   1024   |      32      |
+======+==========+==============+==========+==============+
From the simulation results of BEM-MRH in the figure, we see that the number of packet copies is 1 for any tree size (refer to the third column of the table).
This indicates that after receiving a multicast packet from a traffic source such as a CE, the ingress/root of the tree can encapsulate one packet copy and send the packet to the egress/leaf nodes of the tree through using BEM-MRH.
From the simulation results of BIER in the figure, we see that the number of packet copies is from 12 to 32 for tree size from 16 to 128 (refer to the last column of the table).
This indicates that after receiving a multicast packet from a traffic source such as a CE, the ingress/root of the tree need to make 12 to 32 packet copies, encapsulate each of the copies and send the packet copies to the egress/leaf nodes of the tree through using BIER.
From the simulation results of BEM-MRH in the figure, we see that the total size of the encoding tree is 32 (bytes) for a tree with 16 leaves/egresses, 48 (bytes) for a tree with 24 leaves/egresses, ..., 256 (bytes) for a tree with 128 leaves/egresses (refer to the second column of the table).
The total size of the encoding tree is always less than or equal to two times the tree size.
From the simulation results of BIER in the figure, we see that the total size of the encoding tree is from 384 to 1024 (bytes) for a tree with size from 16 to 128 (leaves/egresses) (refer to the fourth column of the table).

Security Considerations
No.

IANA Considerations
No IANA is requested.

Acknowledgements
TBD

Normative References

Informative References
[RFC2119]
[RFC8174]
[I-D.chen-pim-be-mrh]
[RFC8279]
[I-D.lx-msr6-rgb-segment]